/*

Siesta 5.2.0
Copyright(c) 2009-2019 Bryntum AB
https://bryntum.com/contact
https://bryntum.com/products/siesta/license

*/
/**

@class Siesta.Test.Action.Wheel
@extends Siesta.Test.Action
@mixin Siesta.Test.Action.Role.HasTarget

This action can be included in the `t.chain` call with the "wheel" shortcut:

    t.chain(
        {
            action      : 'wheel',
            target      : someDOMElement,
            options     : { deltaY : 10 }
        },
        // or
        {
            wheel       : someDOMElement,
            options     : { deltaY : 10 }
        }
    )

This action will perform a {@link Siesta.Test.Browser#wheel wheel} action on the provided {@link #target}.

*/
Class('Siesta.Test.Action.Wheel', {
    
    isa         : Siesta.Test.Action,
    
    does        : Siesta.Test.Action.Role.HasTarget,
        
    has : {
        requiredTestMethod  : 'wheel'
    },

    methods : {
        
        process : function () {
            this.test.wheel(this.getTarget(), this.next, null, this.options, this.offset, this.waitForTarget);
        }
    }
});


Siesta.Test.ActionRegistry().registerAction('wheel', Siesta.Test.Action.Wheel);
