export const delay = <T = any>(time : number = 50, result? : T) : Promise<T> => {
    return new Promise((resolve, reject) => {
        setTimeout(() => resolve(result), time)
    })
}


export const timeout = function (time : number, action? : ((...args: any[]) => void)) : Function {
    const handler = setTimeout(action || function () {}, time)

    return () => {
        clearTimeout(handler)
    }
}
