Ext.data.JsonP.Siesta_Test_Action_MethodCall({"tagname":"class","name":"Siesta.Test.Action.MethodCall","autodetected":{},"files":[{"filename":"MethodCall.js","href":"MethodCall.html#Siesta-Test-Action-MethodCall"}],"extends":"Siesta.Test.Action","members":[{"name":"args","tagname":"cfg","owner":"Siesta.Test.Action.MethodCall","id":"cfg-args","meta":{}},{"name":"callbackIndex","tagname":"cfg","owner":"Siesta.Test.Action.MethodCall","id":"cfg-callbackIndex","meta":{}},{"name":"desc","tagname":"cfg","owner":"Siesta.Test.Action","id":"cfg-desc","meta":{}},{"name":"methodName","tagname":"cfg","owner":"Siesta.Test.Action.MethodCall","id":"cfg-methodName","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-Siesta.Test.Action.MethodCall","short_doc":"This action allows you to call any method of the test class. ...","component":false,"superclasses":["Siesta.Test.Action"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/Siesta.Test.Action' rel='Siesta.Test.Action' class='docClass'>Siesta.Test.Action</a><div class='subclass '><strong>Siesta.Test.Action.MethodCall</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/MethodCall.html#Siesta-Test-Action-MethodCall' target='_blank'>MethodCall.js</a></div></pre><div class='doc-contents'><p>This action allows you to call any method of the test class. You can add it to the <code>chain</code> method by providing a property in the config object,\nwhich corresponds to some method of the test class. The value of this property should contain arguments for the method call (see <a href=\"#!/api/Siesta.Test.Action.MethodCall-cfg-args\" rel=\"Siesta.Test.Action.MethodCall-cfg-args\" class=\"docClass\">args</a>).</p>\n\n<pre><code>t.chain(\n    function (next) {\n        t.someMethodCall('arg1', 'arg2', next)\n    },\n    // or\n    {\n        someMethodCall  : [ 'arg1', 'arg2' ]\n    },\n    ...\n    {\n        waitForSelector : '.selector'\n    }\n)\n</code></pre>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-cfg'>Config options</h3><div class='subsection'><div id='cfg-args' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.MethodCall'>Siesta.Test.Action.MethodCall</span><br/><a href='source/MethodCall.html#Siesta-Test-Action-MethodCall-cfg-args' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.MethodCall-cfg-args' class='name expandable'>args</a> : Array/Function/Object<span class=\"signature\"></span></div><div class='description'><div class='short'>Arguments for the method call. ...</div><div class='long'><p>Arguments for the method call. Usually should be an array.</p>\n\n<p>If its a function, then the function will be called at the action execution time and result from the\naction will be treated as <code>args</code>. The only exception is the \"waitForFn\" method, for which the supplied function\nwill be treated as the 1st argument for the \"waitForFn\" method.</p>\n\n<p>Anything else will be converted to a single element array.</p>\n\n<p>The callback will be added as the last argument (after resolving this config), unless the <a href=\"#!/api/Siesta.Test.Action.MethodCall-cfg-callbackIndex\" rel=\"Siesta.Test.Action.MethodCall-cfg-callbackIndex\" class=\"docClass\">callbackIndex</a> is specified.</p>\n</div></div></div><div id='cfg-callbackIndex' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.MethodCall'>Siesta.Test.Action.MethodCall</span><br/><a href='source/MethodCall.html#Siesta-Test-Action-MethodCall-cfg-callbackIndex' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.MethodCall-cfg-callbackIndex' class='name expandable'>callbackIndex</a> : Number<span class=\"signature\"></span></div><div class='description'><div class='short'><p>An index in the <a href=\"#!/api/Siesta.Test.Action.MethodCall-cfg-args\" rel=\"Siesta.Test.Action.MethodCall-cfg-args\" class=\"docClass\">args</a> array where the callback should be inserted.</p>\n</div><div class='long'><p>An index in the <a href=\"#!/api/Siesta.Test.Action.MethodCall-cfg-args\" rel=\"Siesta.Test.Action.MethodCall-cfg-args\" class=\"docClass\">args</a> array where the callback should be inserted.</p>\n</div></div></div><div id='cfg-desc' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/Siesta.Test.Action' rel='Siesta.Test.Action' class='defined-in docClass'>Siesta.Test.Action</a><br/><a href='source/Action4.html#Siesta-Test-Action-cfg-desc' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action-cfg-desc' class='name expandable'>desc</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'>When provided, once step is completed, a passing assertion with this text will be added to a test. ...</div><div class='long'><p>When provided, once step is completed, a passing assertion with this text will be added to a test.\nThis configuration option can be useful to indicate the progress of \"wait\" steps</p>\n</div></div></div><div id='cfg-methodName' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Siesta.Test.Action.MethodCall'>Siesta.Test.Action.MethodCall</span><br/><a href='source/MethodCall.html#Siesta-Test-Action-MethodCall-cfg-methodName' target='_blank' class='view-source'>view source</a></div><a href='#!/api/Siesta.Test.Action.MethodCall-cfg-methodName' class='name expandable'>methodName</a> : String<span class=\"signature\"></span></div><div class='description'><div class='short'><p>A name of the method to call.</p>\n</div><div class='long'><p>A name of the method to call.</p>\n</div></div></div></div></div></div></div>","meta":{}});